Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        RestorePosition(Me, "howto_2005_resize_pics")
        txtDirectory.Text = GetSetting("howto_2005_resize_pics", "Settings", "Directory", Application.StartupPath)
        txtScale.Text = GetSetting("howto_2005_resize_pics", "Settings", "Scale", "0.25")
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        SavePosition(Me, "howto_2005_resize_pics")
        SaveSetting("howto_2005_resize_pics", "Settings", "Directory", txtDirectory.Text)
        SaveSetting("howto_2005_resize_pics", "Settings", "Scale", txtScale.Text)
    End Sub

    Private Sub btnPickDirectory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPickDirectory.Click
        Try
            fbdDirectory.SelectedPath = txtDirectory.Text
        Catch ex As Exception
        End Try

        If fbdDirectory.ShowDialog() = Windows.Forms.DialogResult.OK Then
            txtDirectory.Text = fbdDirectory.SelectedPath
        End If
    End Sub

    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        Dim scale As Single = Val(txtScale.Text)
        If scale = 0 Then
            MessageBox.Show("Scale must not be zero.", "Invalid Scale", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If

        Me.Cursor = Cursors.WaitCursor
        Me.Refresh()

        Dim dir_info As New System.IO.DirectoryInfo(txtDirectory.Text)
        For Each file_info As System.IO.FileInfo In dir_info.GetFiles()
            Try
                Dim ext As String = file_info.Extension.ToLower()
                If ext = ".bmp" OrElse ext = ".gif" OrElse ext = ".jpg" OrElse ext = ".jpeg" Then
                    Dim bm As New Bitmap(file_info.FullName)
                    picWorking.Image = bm
                    Me.Text = "howto_2005_resize_pics - " & file_info.Name
                    Application.DoEvents()

                    Dim from_rect As New Rectangle(0, 0, bm.Width, bm.Height)

                    Dim bm2 As New Bitmap(CInt(scale * bm.Width), CInt(scale * bm.Height))
                    Dim dest_rect As New Rectangle(0, 0, CInt(scale * bm.Width), CInt(scale * bm.Height))
                    Using gr As Graphics = Graphics.FromImage(bm2)
                        gr.InterpolationMode = Drawing2D.InterpolationMode.HighQualityBicubic
                        gr.DrawImage(bm, dest_rect, from_rect, GraphicsUnit.Pixel)
                    End Using

                    Dim new_name As String = file_info.FullName
                    new_name = new_name.Substring(0, new_name.Length - ext.Length)
                    new_name &= "s" & ext
                    Select Case ext
                        Case ".bmp"
                            bm2.Save(new_name, System.Drawing.Imaging.ImageFormat.Bmp)
                        Case ".gif"
                            bm2.Save(new_name, System.Drawing.Imaging.ImageFormat.Gif)
                        Case ".jpg", "jpeg"
                            bm2.Save(new_name, System.Drawing.Imaging.ImageFormat.Jpeg)
                    End Select
                End If
            Catch ex As Exception
                MessageBox.Show("Error processing file '" & _
                    file_info.Name & "'" & vbCrLf & ex.Message, _
                    "Error", _
                    MessageBoxButtons.OK, _
                    MessageBoxIcon.Error)
            End Try
        Next file_info

        picWorking.Image = Nothing
        Me.Text = "howto_2005_resize_pics"
        Me.Cursor = Cursors.Default
    End Sub

    ' Save the form's size and position.
    Private Sub SavePosition(ByVal frm As Form, ByVal app_name As String)
        SaveSetting(app_name, "Geometry", "WindowState", frm.WindowState)
        If frm.WindowState = FormWindowState.Normal Then
            SaveSetting(app_name, "Geometry", "Left", frm.Left)
            SaveSetting(app_name, "Geometry", "Top", frm.Top)
            SaveSetting(app_name, "Geometry", "Width", frm.Width)
            SaveSetting(app_name, "Geometry", "Height", frm.Height)
        Else
            SaveSetting(app_name, "Geometry", "Left", frm.RestoreBounds.Left)
            SaveSetting(app_name, "Geometry", "Top", frm.RestoreBounds.Top)
            SaveSetting(app_name, "Geometry", "Width", frm.RestoreBounds.Width)
            SaveSetting(app_name, "Geometry", "Height", frm.RestoreBounds.Height)
        End If
    End Sub

    ' Restore the form's size and position.
    Private Sub RestorePosition(ByVal frm As Form, ByVal app_name As String)
        frm.SetBounds( _
            GetSetting(app_name, "Geometry", "Left", Me.RestoreBounds.Left), _
            GetSetting(app_name, "Geometry", "Top", Me.RestoreBounds.Top), _
            GetSetting(app_name, "Geometry", "Width", Me.RestoreBounds.Width), _
            GetSetting(app_name, "Geometry", "Height", Me.RestoreBounds.Height) _
        )
        Me.WindowState = GetSetting(app_name, "Geometry", "WindowState", Me.WindowState)
    End Sub
End Class
